//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <deque>
#include <algorithm>

#include "countptr.hpp"
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

void printCountedPtr (CountedPtr<int> elem)
{
  cout << *elem << ' ';
}

int main(int argc, char* argv[])
{
  //    (  
  //   )
  static int values[] = { 3, 5, 9, 1, 6, 4 };

  //    
  typedef CountedPtr<int> IntPtr; 
  deque<IntPtr> coll1; 
  list<IntPtr> coll2;

  //     
  // -    coll1
  // -    coll2

  for (int i=0; i<sizeof(values)/sizeof(values[0]); ++i) { 
    IntPtr ptr(new int(values[i])); 
    coll1.push_back(ptr); 
    coll2.push_front(ptr);
  }

  //     
  cout << ToRus(" coll1:\n");
  for_each (coll1.begin(),coll1.end(),  
            printCountedPtr); 
  cout << endl;

  cout << ToRus(" coll2:\n");
  for_each (coll2.begin(), coll2.end(),
            printCountedPtr); 
  cout << endl << endl;

 //     
 // -       coll1
 // -      coll1
 // -     coll2

 *coll1[2] *= *coll1[2]; 
  (**coll1.begin()) *= -1; 
  (**coll2.begin()) = 0;

  //      
  cout << ToRus(" coll1  :\n");
  for_each (coll1.begin(),coll1.end(),  
            printCountedPtr); 
  cout << endl;

  cout << ToRus(" coll2  :\n");
  for_each (coll2.begin(), coll2.end(),
            printCountedPtr); 
  cout << endl << endl;

  getch();
  return 0;
}

//---------------------------------------------------------------------------